/**
 * Depth First Search - DFS
 *
 * Complexity (Time): O(|V| + |E|)
 * Complexity (Space): O(|V| + |E|)
 */

bool cont[MAX];
vector<int> graph[MAX];

void dfs(int x) {
  cont[x] = true;
  for (auto i : graph[x])
    if (!cont[i])
      dfs(x);
}
